diff a/test/micro/org/openjdk/bench/valhalla/traversal/Identity32.java b/test/micro/org/openjdk/bench/valhalla/traversal/Identity32.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/traversal/Identity32.java
@@ -0,0 +1,89 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.traversal;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.R32int;
+import org.openjdk.bench.valhalla.util.Utils;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+public class Identity32 extends SizeBase {
+
+    public static abstract class IntState extends SizeState {
+        public Int32[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new R32int(a[i]);
+            }
+        }
+    }
+
+    public static abstract class RefState extends SizeState {
+        public R32int[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new R32int(a[i]);
+            }
+        }
+    }
+
+    public static class Int_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Int32[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new R32int[size];
+            fill();
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_walk(Int_as_Int s) {
+        int steps = 0;
+        Int32[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_walk(Ref_as_Ref s) {
+        int steps = 0;
+        R32int[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/traversal/Identity64.java b/test/micro/org/openjdk/bench/valhalla/traversal/Identity64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/traversal/Identity64.java
@@ -0,0 +1,169 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.traversal;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.bench.valhalla.types.A64long;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.bench.valhalla.util.Utils;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+public class Identity64 extends SizeBase {
+
+    public static abstract class IntState extends SizeState {
+        public Int64[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new R64long(a[i]);
+            }
+        }
+    }
+
+    public static abstract class AbsState extends SizeState {
+        public A64long[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new R64long(a[i]);
+            }
+        }
+    }
+
+    public static abstract class RefState extends SizeState {
+        public R64long[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new R64long(a[i]);
+            }
+        }
+    }
+
+
+    public static class Int_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Int64[size];
+            fill();
+        }
+    }
+
+    public static class Abs_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new A64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static class Abs_as_Abs extends AbsState {
+        @Setup
+        public void setup() {
+            arr = new A64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Abs extends AbsState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_walk(Int_as_Int s) {
+        int steps = 0;
+        Int64[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Abs_as_Int_walk(Abs_as_Int s) {
+        int steps = 0;
+        Int64[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Int_walk(Ref_as_Int s) {
+        int steps = 0;
+        Int64[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Abs_as_Abs_walk(Abs_as_Abs s) {
+        int steps = 0;
+        A64long[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Abs_walk(Ref_as_Abs s) {
+        int steps = 0;
+        A64long[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_walk(Ref_as_Ref s) {
+        int steps = 0;
+        A64long[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/traversal/Inline32.java b/test/micro/org/openjdk/bench/valhalla/traversal/Inline32.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/traversal/Inline32.java
@@ -0,0 +1,117 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.traversal;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.bench.valhalla.util.Utils;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+public class Inline32 extends SizeBase {
+
+    public static abstract class IntState extends SizeState {
+        public Int32[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new Q32int(a[i]);
+            }
+        }
+    }
+
+    public static abstract class RefState extends SizeState {
+        public Q32int[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new Q32int(a[i]);
+            }
+        }
+    }
+
+    public static abstract class ValState extends SizeState {
+        public Q32int[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new Q32int(a[i]);
+            }
+        }
+    }
+
+
+    public static class Int_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Int32[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new Q32int[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Val extends ValState {
+        @Setup
+        public void setup() {
+            arr = new Q32int[size];
+            fill();
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_walk(Int_as_Int s) {
+        int steps = 0;
+        Int32[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_walk(Ref_as_Ref s) {
+        int steps = 0;
+        Q32int[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_walk(Val_as_Val s) {
+        int steps = 0;
+        Q32int[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/traversal/Inline64.java b/test/micro/org/openjdk/bench/valhalla/traversal/Inline64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/traversal/Inline64.java
@@ -0,0 +1,168 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.traversal;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.bench.valhalla.util.Utils;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+public class Inline64 extends SizeBase {
+
+    public static abstract class IntState extends SizeState {
+        public Int64[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new Q64long(a[i]);
+            }
+        }
+    }
+
+    public static abstract class RefState extends SizeState {
+        public Q64long[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new Q64long(a[i]);
+            }
+        }
+    }
+
+    public static abstract class ValState extends SizeState {
+        public Q64long[] arr;
+        void fill() {
+            int[] a = Utils.makeRandomRing(arr.length);
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = new Q64long(a[i]);
+            }
+        }
+    }
+
+
+    public static class Int_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Int64[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Val extends ValState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_walk(Int_as_Int s) {
+        int steps = 0;
+        Int64[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Int_walk(Ref_as_Int s) {
+        int steps = 0;
+        Int64[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Int_walk(Val_as_Int s) {
+        int steps = 0;
+        Int64[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_walk(Ref_as_Ref s) {
+        int steps = 0;
+        Q64long[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_walk(Val_as_Ref s) {
+        int steps = 0;
+        Q64long[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_walk(Val_as_Val s) {
+        int steps = 0;
+        Q64long[] values = s.arr;
+        for (int i = values[0].intValue(); i != 0; i = values[i].intValue()) steps++;
+        return steps;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/traversal/Primitive32.java b/test/micro/org/openjdk/bench/valhalla/traversal/Primitive32.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/traversal/Primitive32.java
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.traversal;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.bench.valhalla.util.Utils;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+public class Primitive32 extends SizeBase {
+
+    public static class IntState extends SizeState {
+        public int[] arr;
+
+        @Setup
+        public void setup() {
+            int[] a = Utils.makeRandomRing(size);
+            arr = new int[a.length];
+            System.arraycopy(a, 0, arr, 0, a.length);
+        }
+
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int walk(IntState s) {
+        int steps = 0;
+        int[] values = s.arr;
+        for (int i = values[0]; i != 0; i = values[i]) steps++;
+        return steps;
+    }
+
+}
+
diff a/test/micro/org/openjdk/bench/valhalla/traversal/Primitive64.java b/test/micro/org/openjdk/bench/valhalla/traversal/Primitive64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/traversal/Primitive64.java
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.traversal;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.bench.valhalla.util.Utils;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Setup;
+
+public class Primitive64 extends SizeBase {
+
+    public static class LongState extends SizeState {
+        public long[] arr;
+
+        @Setup
+        public void setup() {
+            int[] a = Utils.makeRandomRing(size);
+            arr = new long[a.length];
+            for (int i = 0; i < a.length; i++) {
+                arr[i] = a[i];
+            }
+        }
+
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int walk(LongState s) {
+        int steps = 0;
+        long[] values = s.arr;
+        for (int i = (int) values[0]; i != 0; i = (int) values[i]) steps++;
+        return steps;
+    }
+
+}
+
diff a/test/micro/org/openjdk/bench/valhalla/types/A64long.java b/test/micro/org/openjdk/bench/valhalla/types/A64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/A64long.java
@@ -0,0 +1,27 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public abstract class A64long implements Int64, ByLong {
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/ByByte.java b/test/micro/org/openjdk/bench/valhalla/types/ByByte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/ByByte.java
@@ -0,0 +1,29 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface ByByte {
+
+    public byte byteSum();
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/ByInt.java b/test/micro/org/openjdk/bench/valhalla/types/ByInt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/ByInt.java
@@ -0,0 +1,29 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface ByInt {
+
+    public int intSum();
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/ByLong.java b/test/micro/org/openjdk/bench/valhalla/types/ByLong.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/ByLong.java
@@ -0,0 +1,29 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface ByLong {
+
+    public long longSum();
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Complex.java b/test/micro/org/openjdk/bench/valhalla/types/Complex.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Complex.java
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface Complex {
+
+    double re();
+
+    double im();
+
+    Complex add(Complex that);
+
+    Complex mul(Complex that);
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Int128.java b/test/micro/org/openjdk/bench/valhalla/types/Int128.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Int128.java
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface Int128 {
+
+    public int intValue();
+
+    public long longValue();
+
+    public long hiValue();
+
+    public long loValue();
+
+}
